commit 77d5883f4db4ca065f511fb57be512a22f9c5c04
Author: Olga Brani <olgabrani@grnet.gr>
Date:   Mon Nov 11 13:55:08 2013 +0200

    new ui: various style fixes

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html b/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
index 2c7b1b7..8194e89 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/vm_list.html
@@ -782,7 +782,7 @@ Confirm that the options you have selected are correct</p>
 							<h4 tilte="create new machine">New Machine</h4>
 						</div>
 					</li>
-					<li data-status="building">
+					<li data-status="building" class="building">
 						<a href="" class="btn5 temp">animation</a>
 						<div class="more">
 							<div class="clearfix">
@@ -823,7 +823,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="error">
+					<li data-status="error" class="error">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -862,7 +862,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="running">
+					<li data-status="running" class="running">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -899,7 +899,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="rebooting">
+					<li data-status="rebooting" classs="rebooting">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -939,7 +939,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="starting">
+					<li data-status="starting" class="starting">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -977,7 +977,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li  data-status="shutting">
+					<li  data-status="shutting" class="shutting">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -1019,7 +1019,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					 <li data-status="running">
+					 <li data-status="running" class="running">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -1061,7 +1061,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="off">
+					<li data-status="off" class="off">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -1098,7 +1098,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="off">
+					<li data-status="off" class="off">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -1136,7 +1136,7 @@ Confirm that the options you have selected are correct</p>
 							<div class="info"><a href="snf-9733.vm.okeanos.grnet.gr" title="">snf-9733.vm.okeanos.grnet.gr</a></div>
 						</div>
 					</li>
-					<li data-status="off">
+					<li data-status="off" class="off">
 						<div class="more">
 							<div class="clearfix">
 								<div class="col lt">
@@ -1181,7 +1181,7 @@ Confirm that the options you have selected are correct</p>
 						<li class="running"><a href="#" title="">Reboot</a></li>
 						<li class="running"><a href="#" title="">Shutdown</a></li>
 						<li class="both"><a href="#">Destroy</a></li>
-						<li class="stopped"><a href="#">Start</a></li>
+						<li class="off"><a href="#">Start</a></li>
 						 <!-- in case we want an action always activated
 						<li class="pernament"><a href="" class="active">Action</a></li> -->
 					</ul>