commit fc78f5b5952ca911deec04d8780f929761bf6882
Author: Athina Bekakou <athinabek@grnet.gr>
Date:   Thu Dec 5 12:56:34 2013 +0200

    new ui: update icon-font and corresponding files

diff --git a/snf-cyclades-app/synnefo/ui/new_ui/ui/icon_guide.html b/snf-cyclades-app/synnefo/ui/new_ui/ui/icon_guide.html
index 628785c..09fd4eb 100644
--- a/snf-cyclades-app/synnefo/ui/new_ui/ui/icon_guide.html
+++ b/snf-cyclades-app/synnefo/ui/new_ui/ui/icon_guide.html
@@ -327,7 +327,7 @@
 		</div>
 		<div class="glyph">
 			<div class="fs1" aria-hidden="true" data-icon="$"></div>
-			<input type="text" readonly="readonly" value="snf-trash [$]" />
+			<input type="text" readonly="readonly" value="snf-trash-outline [$]" />
 		</div>
 	</section>
 	
@@ -369,6 +369,26 @@
 			<div class="fs1" aria-hidden="true" data-icon="M"></div>
 			<input type="text" readonly="readonly" value="snf-arrow-down [M]" />
 		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="_"></div>
+			<input type="text" readonly="readonly" value="snf-arrow-left-small-full [_]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="-"></div>
+			<input type="text" readonly="readonly" value="snf-arrow-right-small-full [-]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="("></div>
+			<input type="text" readonly="readonly" value="snf-upload-full [()]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="%"></div>
+			<input type="text" readonly="readonly" value="snf-download-full [%]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon=")"></div>
+			<input type="text" readonly="readonly" value="snf-refresh-outline [)]" />
+		</div>
 	</section>
 
 	<section>
@@ -396,43 +416,34 @@
 		<div class="glyph">
 			<div class="fs1" aria-hidden="true" data-icon="o"></div>
 			<input type="text" readonly="readonly" value="snf-info-outline [o]" />
-		</div>	
+		</div>
 		<div class="glyph">
 			<div class="fs1" aria-hidden="true" data-icon="p"></div>
 			<input type="text" readonly="readonly" value="snf-info-full [p]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="*"></div>
+			<input type="text" readonly="readonly" value="snf-person-outline [*]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="^"></div>
+			<input type="text" readonly="readonly" value="snf-folder-outline [^]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="="></div>
+			<input type="text" readonly="readonly" value="snf-folder-full [=]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="?"></div>
+			<input type="text" readonly="readonly" value="snf-copy-outline [?]" />
+		</div>
+		<div class="glyph">
+			<div class="fs1" aria-hidden="true" data-icon="&"></div>
+			<input type="text" readonly="readonly" value="snf-link-outline [&]" />
 		</div>	
 	</section>
 
 </section>
-<header>
-		<h1> Missing Icons from snf-font (or not final yet)</h1>
-</header>
-<section>
-	<ul>
-		<li class="box1">pithos icon <span class="note">(final?)</span ></li>
-		<li class="box1">disk icon <span class="note">(final?)</span ></li>
-		<li class="box1">vm icon outline <span class="note">(final?)</span ></li>
-		<li class="box1">network icon outline <span class="note">(final?)</span ></li>
-		<li class="box1">keys? icon</li>
-		<li class="box1">ips icon</li>
-		<li class="box1">folder icon</li>
-		<li class="box1">pdf icon</li>
-		<li class="box1">txt icon</li>
-		<li class="box1">xls icon</li>
-		<li class="box1">doc icon</li>
-		<li class="box1">audio file icon</li>
-		<li class="box1">video file icon</li>
-		<li class="box1">image icon</li>
-		<li class="box1">trash icon</li>
-		<li class="box1">download icon</li>
-		<li class="box1">delete icon</li>
-		<li class="box1">move? icon</li>
-		<li class="box1">get link? icon</li>
-		<li class="box1">preview icon <span class="note">(final?)</span ></li>
-					<li  class="box1">edit icon <span class="note">(not final)</span></li>
-		<li class="box1">cancel edit icon <span class="note">(not final)</span></li>
-	</ul>
-</section>
 </div>	
 </body>
 </html>
\ No newline at end of file