commit 79f92570abeab92028ac53b2541c295a61c258a5
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Wed Mar 7 13:58:41 2012 +0200

    Added file event batching

diff --git a/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj b/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
index 65eb73e..d4716f3 100644
--- a/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
+++ b/trunk/Pithos.Setup.x64/Pithos.Setup.x64.vdproj
@@ -21,6 +21,18 @@
         }
         "Entry"
         {
+        "MsmKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "MsmSig" = "8:_UNDEFINED"
+        }
+        "Entry"
+        {
+        "MsmKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
+        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
+        "MsmSig" = "8:_UNDEFINED"
+        }
+        "Entry"
+        {
         "MsmKey" = "8:_392252B203784D91A39016FC82CD5887"
         "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
@@ -63,24 +75,6 @@
         }
         "Entry"
         {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
         "MsmKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
         "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
@@ -171,12 +165,6 @@
         }
         "Entry"
         {
-        "MsmKey" = "8:_928344C82AF3698D55890E76C45404A5"
-        "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
         "MsmKey" = "8:_A490E069DF5DE5852575B6E157EB50BE"
         "OwnerKey" = "8:_1BD6A9CD577C40098C968C8B464A03BC"
         "MsmSig" = "8:_UNDEFINED"
@@ -370,12 +358,6 @@
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_928344C82AF3698D55890E76C45404A5"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
-        "MsmKey" = "8:_UNDEFINED"
         "OwnerKey" = "8:_8A9B95E5C0E945ECA7F21580A0D088D9"
         "MsmSig" = "8:_UNDEFINED"
         }
@@ -394,7 +376,7 @@
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
+        "OwnerKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -604,20 +586,20 @@
         }
         "File"
         {
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_392252B203784D91A39016FC82CD5887"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_263B85E7C62D146E20358A3F08BBC740"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:WPFToolkit.Extended, Version=1.5.0.0, Culture=neutral, PublicKeyToken=3e4669d2f30244f4, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:System.Threading.Tasks.Dataflow, Version=0.0.4098.29463, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_392252B203784D91A39016FC82CD5887"
+                    "_263B85E7C62D146E20358A3F08BBC740"
                     {
-                    "Name" = "8:WPFToolkit.Extended.dll"
+                    "Name" = "8:System.Threading.Tasks.Dataflow.dll"
                     "Attributes" = "3:512"
                     }
                 }
-            "SourcePath" = "8:WPFToolkit.Extended.dll"
+            "SourcePath" = "8:System.Threading.Tasks.Dataflow.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -635,20 +617,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_4C5B93BC82FE5E63E01458A8DA46B4D6"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_392252B203784D91A39016FC82CD5887"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:Castle.ActiveRecord, Version=3.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:WPFToolkit.Extended, Version=1.5.0.0, Culture=neutral, PublicKeyToken=3e4669d2f30244f4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_4C5B93BC82FE5E63E01458A8DA46B4D6"
+                    "_392252B203784D91A39016FC82CD5887"
                     {
-                    "Name" = "8:Castle.ActiveRecord.dll"
+                    "Name" = "8:WPFToolkit.Extended.dll"
                     "Attributes" = "3:512"
                     }
                 }
-            "SourcePath" = "8:Castle.ActiveRecord.dll"
+            "SourcePath" = "8:WPFToolkit.Extended.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -666,20 +648,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_586310F986FB0DB4F49D3EAFBD87760C"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_4C5B93BC82FE5E63E01458A8DA46B4D6"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:log4net, Version=1.2.11.0, Culture=neutral, PublicKeyToken=669e0ddf0bb1aa2a, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:Castle.ActiveRecord, Version=3.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_586310F986FB0DB4F49D3EAFBD87760C"
+                    "_4C5B93BC82FE5E63E01458A8DA46B4D6"
                     {
-                    "Name" = "8:log4net.dll"
+                    "Name" = "8:Castle.ActiveRecord.dll"
                     "Attributes" = "3:512"
                     }
                 }
-            "SourcePath" = "8:log4net.dll"
+            "SourcePath" = "8:Castle.ActiveRecord.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -697,20 +679,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_5B7E11B508E123A2BA4C11623DA3E029"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_586310F986FB0DB4F49D3EAFBD87760C"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:System.Threading.Tasks.Dataflow, Version=0.0.4098.29463, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:log4net, Version=1.2.11.0, Culture=neutral, PublicKeyToken=669e0ddf0bb1aa2a, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
-                    "_5B7E11B508E123A2BA4C11623DA3E029"
+                    "_586310F986FB0DB4F49D3EAFBD87760C"
                     {
-                    "Name" = "8:System.Threading.Tasks.Dataflow.dll"
+                    "Name" = "8:log4net.dll"
                     "Attributes" = "3:512"
                     }
                 }
-            "SourcePath" = "8:System.Threading.Tasks.Dataflow.dll"
+            "SourcePath" = "8:log4net.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -883,37 +865,6 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_928344C82AF3698D55890E76C45404A5"
-            {
-            "AssemblyRegister" = "3:1"
-            "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:AppLimit.NetSparkle.Net40, Version=1.0.83.0, Culture=neutral, processorArchitecture=MSIL"
-                "ScatterAssemblies"
-                {
-                    "_928344C82AF3698D55890E76C45404A5"
-                    {
-                    "Name" = "8:AppLimit.NetSparkle.Net40.dll"
-                    "Attributes" = "3:512"
-                    }
-                }
-            "SourcePath" = "8:AppLimit.NetSparkle.Net40.dll"
-            "TargetName" = "8:"
-            "Tag" = "8:"
-            "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
-            "Condition" = "8:"
-            "Transitive" = "11:FALSE"
-            "Vital" = "11:TRUE"
-            "ReadOnly" = "11:FALSE"
-            "Hidden" = "11:FALSE"
-            "System" = "11:FALSE"
-            "Permanent" = "11:FALSE"
-            "SharedLegacy" = "11:FALSE"
-            "PackageAs" = "3:1"
-            "Register" = "3:1"
-            "Exclude" = "11:FALSE"
-            "IsDependency" = "11:TRUE"
-            "IsolateTo" = "8:"
-            }
             "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_A490E069DF5DE5852575B6E157EB50BE"
             {
             "AssemblyRegister" = "3:1"
@@ -1375,15 +1326,15 @@
         {
         "Name" = "8:Microsoft Visual Studio"
         "ProductName" = "8:Pithos"
-        "ProductCode" = "8:{57BE17ED-F02F-43C0-B44B-845697CD3D6A}"
-        "PackageCode" = "8:{A4185E8B-DEC9-4E52-BBE4-B959A8B30DD2}"
+        "ProductCode" = "8:{F0D4CF43-1BE4-4B68-A247-781E31CF37B4}"
+        "PackageCode" = "8:{D8D45676-4CC0-40A9-B6E5-0F58306DF8E7}"
         "UpgradeCode" = "8:{205365D1-28AA-4322-A46C-FCB37502C6EF}"
         "AspNetVersion" = "8:4.0.30319.0"
         "RestartWWWService" = "11:FALSE"
         "RemovePreviousVersions" = "11:TRUE"
         "DetectNewerInstalledVersion" = "11:TRUE"
         "InstallAllUsers" = "11:FALSE"
-        "ProductVersion" = "8:0.7.20302"
+        "ProductVersion" = "8:0.7.20305"
         "Manufacturer" = "8:GRNET"
         "ARPHELPTELEPHONE" = "8:"
         "ARPHELPLINK" = "8:http://code.grnet.gr/projects/pithos-ms-client"