commit 79f92570abeab92028ac53b2541c295a61c258a5
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Wed Mar 7 13:58:41 2012 +0200

    Added file event batching

diff --git a/trunk/Pithos.Setup.x86/Pithos.Setup.x86.vdproj b/trunk/Pithos.Setup.x86/Pithos.Setup.x86.vdproj
index 8b79d3b..284c487 100644
--- a/trunk/Pithos.Setup.x86/Pithos.Setup.x86.vdproj
+++ b/trunk/Pithos.Setup.x86/Pithos.Setup.x86.vdproj
@@ -21,6 +21,18 @@
         }
         "Entry"
         {
+        "MsmKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
+        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
+        "MsmSig" = "8:_UNDEFINED"
+        }
+        "Entry"
+        {
+        "MsmKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
+        "OwnerKey" = "8:_AA1756E83B8A428E9A235CF626FD83B2"
+        "MsmSig" = "8:_UNDEFINED"
+        }
+        "Entry"
+        {
         "MsmKey" = "8:_392252B203784D91A39016FC82CD5887"
         "OwnerKey" = "8:_AA1756E83B8A428E9A235CF626FD83B2"
         "MsmSig" = "8:_UNDEFINED"
@@ -63,24 +75,6 @@
         }
         "Entry"
         {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_E42C4D0836CDB6008642BC929C51E416"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_AA1756E83B8A428E9A235CF626FD83B2"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
-        "MsmKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
-        "OwnerKey" = "8:_A611766CD2793378FFAB2F3063F81496"
-        "MsmSig" = "8:_UNDEFINED"
-        }
-        "Entry"
-        {
         "MsmKey" = "8:_626ECD9012C5D7BD4388B6BE07F5107D"
         "OwnerKey" = "8:_AA1756E83B8A428E9A235CF626FD83B2"
         "MsmSig" = "8:_UNDEFINED"
@@ -382,7 +376,7 @@
         "Entry"
         {
         "MsmKey" = "8:_UNDEFINED"
-        "OwnerKey" = "8:_5B7E11B508E123A2BA4C11623DA3E029"
+        "OwnerKey" = "8:_263B85E7C62D146E20358A3F08BBC740"
         "MsmSig" = "8:_UNDEFINED"
         }
         "Entry"
@@ -592,15 +586,20 @@
         }
         "File"
         {
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_392252B203784D91A39016FC82CD5887"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_263B85E7C62D146E20358A3F08BBC740"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:WPFToolkit.Extended, Version=1.5.0.0, Culture=neutral, PublicKeyToken=3e4669d2f30244f4, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:System.Threading.Tasks.Dataflow, Version=0.0.4098.29463, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_263B85E7C62D146E20358A3F08BBC740"
+                    {
+                    "Name" = "8:System.Threading.Tasks.Dataflow.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
-            "SourcePath" = "8:WPFToolkit.Extended.dll"
+            "SourcePath" = "8:System.Threading.Tasks.Dataflow.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -618,15 +617,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_4C5B93BC82FE5E63E01458A8DA46B4D6"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_392252B203784D91A39016FC82CD5887"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:Castle.ActiveRecord, Version=3.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:WPFToolkit.Extended, Version=1.5.0.0, Culture=neutral, PublicKeyToken=3e4669d2f30244f4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_392252B203784D91A39016FC82CD5887"
+                    {
+                    "Name" = "8:WPFToolkit.Extended.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
-            "SourcePath" = "8:Castle.ActiveRecord.dll"
+            "SourcePath" = "8:WPFToolkit.Extended.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -644,15 +648,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_586310F986FB0DB4F49D3EAFBD87760C"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_4C5B93BC82FE5E63E01458A8DA46B4D6"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:log4net, Version=1.2.11.0, Culture=neutral, PublicKeyToken=669e0ddf0bb1aa2a, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:Castle.ActiveRecord, Version=3.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_4C5B93BC82FE5E63E01458A8DA46B4D6"
+                    {
+                    "Name" = "8:Castle.ActiveRecord.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
-            "SourcePath" = "8:log4net.dll"
+            "SourcePath" = "8:Castle.ActiveRecord.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -670,15 +679,20 @@
             "IsDependency" = "11:TRUE"
             "IsolateTo" = "8:"
             }
-            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_5B7E11B508E123A2BA4C11623DA3E029"
+            "{9F6F8455-1EF1-4B85-886A-4223BCC8E7F7}:_586310F986FB0DB4F49D3EAFBD87760C"
             {
             "AssemblyRegister" = "3:1"
             "AssemblyIsInGAC" = "11:FALSE"
-            "AssemblyAsmDisplayName" = "8:System.Threading.Tasks.Dataflow, Version=0.0.4098.29463, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
+            "AssemblyAsmDisplayName" = "8:log4net, Version=1.2.11.0, Culture=neutral, PublicKeyToken=669e0ddf0bb1aa2a, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_586310F986FB0DB4F49D3EAFBD87760C"
+                    {
+                    "Name" = "8:log4net.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
-            "SourcePath" = "8:System.Threading.Tasks.Dataflow.dll"
+            "SourcePath" = "8:log4net.dll"
             "TargetName" = "8:"
             "Tag" = "8:"
             "Folder" = "8:_FA3E4362540D4C76A5914763C178A3BD"
@@ -703,6 +717,11 @@
             "AssemblyAsmDisplayName" = "8:ParallelExtensionsExtras, Version=1.2.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_626ECD9012C5D7BD4388B6BE07F5107D"
+                    {
+                    "Name" = "8:ParallelExtensionsExtras.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:ParallelExtensionsExtras.dll"
             "TargetName" = "8:"
@@ -729,6 +748,11 @@
             "AssemblyAsmDisplayName" = "8:Caliburn.Micro, Version=1.2.0.0, Culture=neutral, PublicKeyToken=8e5891231f2ed21f, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_6BC141E8128E964AD9B9281537E64BEA"
+                    {
+                    "Name" = "8:Caliburn.Micro.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Caliburn.Micro.dll"
             "TargetName" = "8:"
@@ -755,6 +779,11 @@
             "AssemblyAsmDisplayName" = "8:System.Data.SQLite, Version=1.0.76.0, Culture=neutral, PublicKeyToken=db937bc2d44ff139, processorArchitecture=x86"
                 "ScatterAssemblies"
                 {
+                    "_71EDC030F43F0D5A22D833BE7229E576"
+                    {
+                    "Name" = "8:System.Data.SQLite.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:System.Data.SQLite.dll"
             "TargetName" = "8:"
@@ -781,6 +810,11 @@
             "AssemblyAsmDisplayName" = "8:NHibernate, Version=3.1.0.4000, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_89E3F50B2C3DDF59B632A4BEFEE3D3A1"
+                    {
+                    "Name" = "8:NHibernate.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:NHibernate.dll"
             "TargetName" = "8:"
@@ -807,6 +841,11 @@
             "AssemblyAsmDisplayName" = "8:System.Windows.Interactivity, Version=4.0.0.0, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_91EEC8BDF3543C1C3379FB93171A844E"
+                    {
+                    "Name" = "8:System.Windows.Interactivity.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:System.Windows.Interactivity.dll"
             "TargetName" = "8:"
@@ -833,6 +872,11 @@
             "AssemblyAsmDisplayName" = "8:AsyncCtpLibrary, Version=1.0.4107.18181, Culture=neutral, PublicKeyToken=31bf3856ad364e35, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_A490E069DF5DE5852575B6E157EB50BE"
+                    {
+                    "Name" = "8:AsyncCtpLibrary.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:AsyncCtpLibrary.dll"
             "TargetName" = "8:"
@@ -859,6 +903,11 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Core, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=x86"
                 "ScatterAssemblies"
                 {
+                    "_A611766CD2793378FFAB2F3063F81496"
+                    {
+                    "Name" = "8:Pithos.Core.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Pithos.Core.dll"
             "TargetName" = "8:"
@@ -905,6 +954,11 @@
             "AssemblyAsmDisplayName" = "8:Castle.Components.Validator, Version=2.5.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_B998E7FC1F540278910B0D58694455C2"
+                    {
+                    "Name" = "8:Castle.Components.Validator.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Castle.Components.Validator.dll"
             "TargetName" = "8:"
@@ -931,6 +985,11 @@
             "AssemblyAsmDisplayName" = "8:Newtonsoft.Json, Version=4.0.2.0, Culture=neutral, PublicKeyToken=b9a188c8922137c6, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_C7EE41E4C982C8217BD7DCDA76836670"
+                    {
+                    "Name" = "8:Newtonsoft.Json.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Newtonsoft.Json.dll"
             "TargetName" = "8:"
@@ -957,6 +1016,11 @@
             "AssemblyAsmDisplayName" = "8:NHibernate.ByteCode.Castle, Version=3.1.0.4000, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_DD69E9C0F36E10A97EB92CFBAFD2662D"
+                    {
+                    "Name" = "8:NHibernate.ByteCode.Castle.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:NHibernate.ByteCode.Castle.dll"
             "TargetName" = "8:"
@@ -983,6 +1047,11 @@
             "AssemblyAsmDisplayName" = "8:Iesi.Collections, Version=1.0.1.0, Culture=neutral, PublicKeyToken=aa95f207798dfdb4, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_DD70D5956F2E708F680AF121870FFCCD"
+                    {
+                    "Name" = "8:Iesi.Collections.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Iesi.Collections.dll"
             "TargetName" = "8:"
@@ -1009,6 +1078,11 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Network, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_E42C4D0836CDB6008642BC929C51E416"
+                    {
+                    "Name" = "8:Pithos.Network.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Pithos.Network.dll"
             "TargetName" = "8:"
@@ -1035,6 +1109,11 @@
             "AssemblyAsmDisplayName" = "8:Pithos.Interfaces, Version=1.0.0.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_E46F39A63288379E63BDD76C9F21CC3E"
+                    {
+                    "Name" = "8:Pithos.Interfaces.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Pithos.Interfaces.dll"
             "TargetName" = "8:"
@@ -1061,6 +1140,11 @@
             "AssemblyAsmDisplayName" = "8:Castle.Core, Version=2.5.1.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_F472AA6700476700D62AABE8262628BF"
+                    {
+                    "Name" = "8:Castle.Core.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Castle.Core.dll"
             "TargetName" = "8:"
@@ -1087,6 +1171,11 @@
             "AssemblyAsmDisplayName" = "8:Hardcodet.Wpf.TaskbarNotification, Version=1.0.4.0, Culture=neutral, PublicKeyToken=2cc55badaa91f4de, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_FA76529F78D7D6108EDBA33F19836A6B"
+                    {
+                    "Name" = "8:Hardcodet.Wpf.TaskbarNotification.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:Hardcodet.Wpf.TaskbarNotification.dll"
             "TargetName" = "8:"
@@ -1113,6 +1202,11 @@
             "AssemblyAsmDisplayName" = "8:NHibernate.Search, Version=0.0.0.0, Culture=neutral, PublicKeyToken=407dd0808d44fbdc, processorArchitecture=MSIL"
                 "ScatterAssemblies"
                 {
+                    "_FBB2F726C4025B9184DFBD2748E15EBE"
+                    {
+                    "Name" = "8:NHibernate.Search.dll"
+                    "Attributes" = "3:512"
+                    }
                 }
             "SourcePath" = "8:NHibernate.Search.dll"
             "TargetName" = "8:"
@@ -1232,15 +1326,15 @@
         {
         "Name" = "8:Microsoft Visual Studio"
         "ProductName" = "8:Pithos"
-        "ProductCode" = "8:{9BD4270B-BAB7-4FC1-8944-D720A0E4EB2F}"
-        "PackageCode" = "8:{2BF59D3D-C981-4225-97EA-CFCFB41DA44B}"
+        "ProductCode" = "8:{ABBA3B74-FF31-462C-800D-D59AED5562FB}"
+        "PackageCode" = "8:{4BCE4514-9393-4BCB-B76C-5BC126DBD9D7}"
         "UpgradeCode" = "8:{205365D1-28AA-4322-A46C-FCB37502C6EF}"
         "AspNetVersion" = "8:4.0.30319.0"
         "RestartWWWService" = "11:FALSE"
         "RemovePreviousVersions" = "11:TRUE"
         "DetectNewerInstalledVersion" = "11:TRUE"
         "InstallAllUsers" = "11:FALSE"
-        "ProductVersion" = "8:0.7.20302"
+        "ProductVersion" = "8:0.7.20305"
         "Manufacturer" = "8:GRNET"
         "ARPHELPTELEPHONE" = "8:"
         "ARPHELPLINK" = "8:http://code.grnet.gr/projects/pithos-ms-client"