commit f3d080df476f28bb731d09efce2e1538b1fbb420
Author: Panagiotis Kanavos <pkanavos@gmail.com>
Date:   Mon Jan 9 18:54:42 2012 +0200

    Changes for directories
    Added copyright notices

diff --git a/trunk/Pithos.Core/FileState.cs b/trunk/Pithos.Core/FileState.cs
index 59d5e70..df43910 100644
--- a/trunk/Pithos.Core/FileState.cs
+++ b/trunk/Pithos.Core/FileState.cs
@@ -1,6 +1,37 @@
 ﻿// -----------------------------------------------------------------------
-// <copyright file="FileState.cs" company="Microsoft">
-// TODO: Update copyright text.
+// <copyright file="FileState.cs" company="GRNet">
+// Copyright 2011 GRNET S.A. All rights reserved.
+// 
+// Redistribution and use in source and binary forms, with or
+// without modification, are permitted provided that the following
+// conditions are met:
+// 
+//   1. Redistributions of source code must retain the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer.
+// 
+//   2. Redistributions in binary form must reproduce the above
+//      copyright notice, this list of conditions and the following
+//      disclaimer in the documentation and/or other materials
+//      provided with the distribution.
+// 
+// THIS SOFTWARE IS PROVIDED BY GRNET S.A. ``AS IS'' AND ANY EXPRESS
+// OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
+// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+// PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL GRNET S.A OR
+// CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
+// LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
+// USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED
+// AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
+// LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
+// ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+// POSSIBILITY OF SUCH DAMAGE.
+// 
+// The views and conclusions contained in the software and
+// documentation are those of the authors and should not be
+// interpreted as representing official policies, either expressed
+// or implied, of GRNET S.A.
 // </copyright>
 // -----------------------------------------------------------------------
 
@@ -125,7 +156,7 @@ namespace Pithos.Core
                         .ExecuteUpdate();
                 if (updatedEntities == 0)
                 {
-                    var newState = new FileState { FilePath = absolutePath, Id = Guid.NewGuid(), FileStatus = newStatus };
+                    var newState = new FileState { FilePath = absolutePath.ToLower(), Id = Guid.NewGuid(), FileStatus = newStatus };
                     newState.CreateAndFlush();
                 }
                 return null;
@@ -288,7 +319,7 @@ namespace Pithos.Core
 
             var fileState = new FileState
                                 {
-                                    FilePath = filePath, 
+                                    FilePath = filePath.ToLower(), 
                                     OverlayStatus = FileOverlayStatus.Unversioned, 
                                     FileStatus = FileStatus.Created,
                                     Id=Guid.NewGuid()
@@ -298,7 +329,7 @@ namespace Pithos.Core
             return fileState.UpdateHashesAsync(blockSize,algorithm);            
         }
 
-        public Task<FileState> UpdateHashesAsync(int blockSize,string algorithm)
+        public async Task<FileState> UpdateHashesAsync(int blockSize,string algorithm)
         {
             if (blockSize<=0)
                 throw new ArgumentOutOfRangeException("blockSize");
@@ -308,21 +339,17 @@ namespace Pithos.Core
             
             //Skip updating the hash for folders
             if (Directory.Exists(FilePath))
-                return Task.Factory.FromResult(this);
+                return this;
 
-            var results = Task.Factory.StartNew(() =>
+            var hash = await TaskEx.Run(() =>
             {
                 var info = new FileInfo(FilePath);
                 return info.CalculateHash(blockSize, algorithm);
             });
 
-            var state=results.Then(hash =>
-            {
-                Checksum = hash;
-                return Task.Factory.FromResult(this);
-            });
+            Checksum = hash;
             
-            return state;
+            return this;
         }
     }
 